
#define Analog0			PIN_A0
#define Analog1			PIN_A1
#define IN1				PIN_A2
#define OUT2			PIN_A3
#define IN5				PIN_A4
#define IN4				PIN_A5

#define NC1		PIN_B0//InterruptPin nirgends angeschlossen
#define IN3		PIN_B1
#define IN2		PIN_B2
#define IN6		PIN_B3
#define IN7		PIN_B4
#define IN0		PIN_B5
#define IN8		PIN_B6
#define OUT1	PIN_B7

#define Run			PIN_C0
#define OUT0		PIN_C1
#define OUT3 		PIN_C2
#define SRCK 		PIN_C3
#define Matrizen	PIN_C4
#define SIN 		PIN_C5
#define RCK 		PIN_C6
#define G 			PIN_C7

#include <16F872.h>
#device ADC=10
#fuses HS,WDT,NOPROTECT,NOLVP//Einstellungen
#use delay(clock=8000000)//Quarz


void main()   {
	unsigned int16 Sektoren[5],sendvar,dummysektor,Maske;
	int i,Schleifen,bitPos;

	int1 Setzen,Matrizen_alt,initialised;
	port_b_pullups(true);
	initialised = 0;
	i = 1;
	setup_wdt(WDT_2304MS);
	set_tris_c (0b11111111);//PortC alles Eingnge ume Einzulesen welches Programm zu initialisieren ist


	if(!input(Matrizen))//Wechsel auf Matrize
	{	set_tris_a (0b11110111);
		set_tris_b (0b01111111);
		set_tris_c (0b00010000);
		Matrizen_alt = false;
	}
	if((input(Matrizen)))//Wechsel auf normal
	{	set_tris_a (0b11111111);
		set_tris_b (0b11111111);
		set_tris_c (0b00010110);
		Matrizen_alt = true;
	}

do
{	if(!input(Matrizen) != Matrizen_alt)
	{
		if(!input(Matrizen))//Wechsel auf Matrize
		{	set_tris_a (0b11110111);
			set_tris_b (0b01111111);
			set_tris_c (0b00010000);
			Matrizen_alt = false;
		}
		if((input(Matrizen)))//Wechsel auf normal
		{	set_tris_a (0b11111111);
			set_tris_b (0b11111111);
			set_tris_c (0b00010110);
			Matrizen_alt = true;
		}
	}
	if( input(Matrizen) )
	{
		setup_port_a( AN0_AN1_AN3 );
		setup_adc( ADC_CLOCK_INTERNAL );
		set_adc_channel( 3 );
		delay_ms(5);
		output_high( G );

		Sektoren[3] = Read_ADC( );
		if ( !input(PIN_B3) )
		Sektoren[3] = Sektoren[3] + 0b10000000000;
		if ( !input(PIN_A2) ) 
		Sektoren[3] = Sektoren[3] + 0b100000000000;
		if ( !input(PIN_B6) )
		Sektoren[3] = Sektoren[3] + 0b1000000000000;
		if ( !input(PIN_B7) )
		Sektoren[3] = Sektoren[3] + 0b10000000000000;
		Sektoren[3] = Sektoren[3] + 0b1100000000000000;

		set_adc_channel( 1 );
		delay_ms(5);	
		Sektoren[2] = Read_ADC();
	
		if ( !input(PIN_B4) )
		Sektoren[2] = Sektoren[2] + 0b10000000000;
		if ( !input(PIN_B5) )
		Sektoren[2] = Sektoren[2] + 0b100000000000;
		if ( !input(PIN_B1) )
		Sektoren[2] = Sektoren[2] + 0b1000000000000;
		if ( !input(PIN_B2) )
		Sektoren[2] = Sektoren[2] + 0b10000000000000;
		Sektoren[2] = Sektoren[2] + 0b1000000000000000;
	
		set_adc_channel( 0 );
		delay_ms(5);	
		Sektoren[1] = Read_ADC();

		if ( !input(PIN_C1) )
		Sektoren[1] = Sektoren[1] + 0b10000000000;
		if ( !input(PIN_C2) )
		Sektoren[1] = Sektoren[1] + 0b100000000000;
		if ( !input(PIN_A4) )
		Sektoren[1] = Sektoren[1] + 0b1000000000000;
		if ( !input(PIN_A5) )
		Sektoren[1] = Sektoren[1] + 0b10000000000000;
		Sektoren[1] = Sektoren[1] + 0b0100000000000000;
		Sektoren[4] = 0;
	}
	else//hier Matrize
	{	Dummysektor = 0;
		setup_port_a( AN0_AN1_AN3 );
		setup_adc( ADC_CLOCK_INTERNAL );

		switch (i){									//
		case 1 :restart_wdt();

			Output_high(Out1);//ZweiteLinie
			Output_low(Out0);
			Output_low(Out2);
			Output_low(Out3);

			Maske = 0;
			Maske = Maske + !input(In4);
			Maske = Maske * 2;
			Maske = Maske + !input(In3);
			Maske = Maske * 2;
			Maske = Maske + !input(In2);
			Maske = Maske * 2;
			Maske = Maske + !input(In1);
			Maske = Maske * 2;
			Maske = Maske + !input(In0);

			Output_high(Out0);//ErsteLinie
			Output_low(Out1);
			Output_low(Out2);
			Output_low(Out3);

			Maske = Maske * 2;
			Maske = Maske + !input(In8);
			Maske = Maske * 2;
			Maske = Maske + !input(In7);
			Maske = Maske * 2;
			Maske = Maske + !input(In6);
			Maske = Maske * 2;
			Maske = Maske + !input(In5);
			Maske = Maske * 2;
			Maske = Maske + !input(In4);
			Maske = Maske * 2;
			Maske = Maske + !input(In3);
			Maske = Maske * 2;
			Maske = Maske + !input(In2);
			Maske = Maske * 2;
			Maske = Maske + !input(In1);
			Maske = Maske * 2;
			Maske = Maske + !input(In0);

			Sektoren[1] = Maske + 0b0000000000000000;
			break;
		case 2 :restart_wdt();

			Output_high(Out3);//LetzteLinie
			Output_low(Out0);
			Output_low(Out1);
			Output_low(Out2);

			Maske = 0;
			Maske = Maske + !input(In0);

			Output_high(Out2);//DritteLinie
			Output_low(Out0);
			Output_low(Out1);
			Output_low(Out3);

			Maske = Maske * 2;
			Maske = Maske + !input(In8);
			Maske = Maske * 2;
			Maske = Maske + !input(In7);
			Maske = Maske * 2;
			Maske = Maske + !input(In6);
			Maske = Maske * 2;
			Maske = Maske + !input(In5);
			Maske = Maske * 2;
			Maske = Maske + !input(In4);
			Maske = Maske * 2;
			Maske = Maske + !input(In3);
			Maske = Maske * 2;
			Maske = Maske + !input(In2);
			Maske = Maske * 2;
			Maske = Maske + !input(In1);
			Maske = Maske * 2;
			Maske = Maske + !input(In0);

			Output_high(Out1);//ZweiteLinie
			Output_low(Out0);
			Output_low(Out2);
			Output_low(Out3);

			Maske = Maske * 2;
			Maske = Maske + !input(In8);
			Maske = Maske * 2;
			Maske = Maske + !input(In7);
			Maske = Maske * 2;
			Maske = Maske + !input(In6);
			Maske = Maske * 2;
			Maske = Maske + !input(In5);

			Sektoren[2]= Maske+0b0100000000000000;
			set_adc_channel( 1 );
			break;
		case 3 :restart_wdt();
			Output_high(Out3);//LetzteLinie
			Output_low(Out0);
			Output_low(Out1);
			Output_low(Out2);

			Maske = 0;
			Maske = Maske + !input(In4);
			Maske = Maske * 2;
			Maske = Maske + !input(In3);
			Maske = Maske * 2;	
			Maske = Maske + !input(In2);
			Maske = Maske * 2;	
			Maske = Maske + !input(In1);

			Sektoren[3]=0b1000000000000000;
			Sektoren[3]=Sektoren[3] + Maske *1024 ;	
			delay_ms(1);	
			Sektoren[3] = Sektoren[3] + (Read_ADC());
			set_adc_channel( 0 );
		break;
		case 4 :restart_wdt();

			Output_high(Out3);//LetzteLinie
			Output_low(Out0);
			Output_low(Out1);
			Output_low(Out2);
 
			Maske = 0;
			Maske = Maske + !input(In8);
			Maske = Maske * 2;
			Maske = Maske + !input(In7);
			Maske = Maske * 2;
			Maske = Maske + !input(In6);
			Maske = Maske * 2;
			Maske = Maske + !input(In5);

			Sektoren[4]=0b1100000000000000;
			Sektoren[4]=Sektoren[4] + Maske *1024 ;		
			delay_ms(1);	
			Sektoren[4] = Sektoren[4] + (Read_ADC());
		break;
	default	:

			Output_low(Out0);
			Output_low(Out1);
			Output_low(Out2);
			Output_low(Out3);
			i=1;
		break;
		}
	}
	restart_wdt();	
	
	i++;
	if ( i>4 ) 
		i=1;
	sendvar = Sektoren[i];
	//Kommunikation
	Schleifen = 0;
	do 
	{
		++Schleifen;
		if (sendvar >= 0b1000000000000000) {
			output_high (Sin);
			sendvar = sendvar - 0b1000000000000000;
			sendvar = sendvar * 2;
			}
		else	{
			output_low (Sin);
			sendvar = sendvar *2;
			}

		restart_wdt();
		output_high (SRCK);
		delay_ms(2);
		output_low (SRCK);
		delay_ms(2);
	} while	(Schleifen <=15); 
	output_high (RCK);			//Seriellen Ausgang bernehmen und seriellen eingang abspeichern
	delay_ms (2);
	output_low (RCK);			//rcksetzen
	delay_ms (2);
	output_low(G);
	if(i==1)
		output_high(Run);
	else
		output_low(Run);
		//output_toggle(Run);
	Matrizen_alt = input(Matrizen);
}
while (true);
}



